
    #	Bit happens, and who 'ya gonna call?
    
    #	In the process of three months of computing, unanticipated
    #	things happen--disc full crises, operating system crashes,
    #	you name it.  When one of these wipes a segment of one
    #	of our event files generated by transit.c, this program
    #	allows replacing the damaged segment with a replacement
    #	run of the integrator and transits.c.
    
    #	by John Walker
    #	http://www.fourmilab.ch/
    
    #	For details, please see: http://www.fourmilab.ch/documents/canon_transits/

    use strict;
    use warnings;
    
    my $origfile = '../Ask/backward_fine_1.txt';
    my $rerunfile = 'replacement_backward_1.txt';
    my $newfile = 'new_backward_fine_1.txt';
    
    open(ORIG, "<$origfile") || die "Cannot open $origfile";
    open(RERUN, "<$rerunfile") || die "Cannot open $rerunfile";
    open(NEW, ">$newfile") || die "Cannot open $newfile";
    
    my ($r, $o, $p);
    
    $r = <RERUN>;
    
    #	Transcribe old file to new until we find a record in the
    #	old file which matches the first record of the re-run.
    
    my ($sr, $so);
    
    $r =~ m/^(Transit of \w+\s+from\s+\w+\s+[\-\.\d]+\s)/;
    $sr = $1;
    while ($o = <ORIG>) {
    	$o =~ m/^(Transit of \w+\s+from\s+\w+\s+[\-\.\d]+\s)/;
    	$so = $1;
	    	
    	if ($so eq $sr) {
	    last;
	}
	print(NEW $o);
    }
    
    if ($so ne $sr) {
    	print("$r$o");
    	die("Dooooh!  Didn't find match for first line of $rerunfile in $origfile");
    }
    
    #	Transcribe rerun file to new file, saving last line of rerun to
    #	match against original file.
    
    print(NEW $r);
    while ($r = <RERUN>) {
    	print(NEW $r);
	$p = $r;
    }
    
    #	Ignore lines of original file until we find one which matches the
    #	last line of the rerun.
    
    $p =~ m/^(Transit of \w+\s+from\s+\w+\s+[\-\.\d]+\s)/;
    $sr = $1;
    while ($o = <ORIG>) {
    	$o =~ m/^(Transit of \w+\s+from\s+\w+\s+[\-\.\d]+\s)/;
    	$so = $1;
    	if ($so eq $sr) {
	    last;
	}
    }
    
    if ($so ne $sr) {
    	die("Dooooh!  Didn't find last line of $rerunfile in $origfile");
    }
    
    #	Transcribe balance of original file to new file
    
    while ($o = <ORIG>) {
    	print(NEW $o);
    }
    
    
    close(ORIG);
    close(RERUN);
    close(NEW);
